Require Import ssreflect ssrbool ssrnat eqtype seq ssrfun.
Require Import heaps rels hprop stmod stsep stlog stlogR. 
Set Implicit Arguments.
Unset Strict Implicit.
Import Prenex Implicits.
Set Automatic Coercions Import.

Variable (B : Type).

Lemma foo x2 e (q : cont B) : 
  verify (x2 :-> 4 :+ empty) (e tt) q ->
  verify (x2 :-> 2 :+ empty) (bind_s (write_s x2 4) e) q.
Proof.
  move=> H; by apply: bnd_write.
Qed.

Lemma foo' x2 e (q : cont B) : 
  verify (x2 :-> 4 :+ empty) (e tt) q ->
  verify (x2 :-> 2 :+ empty) (bind_s (write_s x2 4) e) q.
Proof.
  move=> H; by apply: bnd_writeR.
Qed.

(* the above now unifies, it required apply: bnd_writeR, not apply bnd_writeR *)
(* the former is the ssreflect's apply, the latter is Coq's default apply *)

Lemma bar h1 x1 x2 h2 x3 e (q : cont B) : 
  verify (x2 :-> 4 :+ (x1 :-> 1 :+ h1 :+ (h2 :+ x3 :-> 3))) (e tt) q -> 
  verify (x2 :-> 2 :+ ((x1 :-> 1 :+ h1) :+ (h2 :+ x3 :-> 3))) (bind_s (write_s x2 4) e) q.
Proof. move=> H; by apply: bnd_write. Qed.

Lemma bar' h1 x1 x2 h2 x3 e (q : cont B) : 
  verify (x2 :-> 4 :+ (x1 :-> 1 :+ h1 :+ (h2 :+ x3 :-> 3))) (e tt) q -> 
  verify (x2 :-> 2 :+ ((x1 :-> 1 :+ h1) :+ (h2 :+ x3 :-> 3))) (bind_s (write_s x2 4) e) q.
Proof.
  move=> H; by apply: bnd_writeR.
Qed.

(* the above typechecked as is, although Reviewer C marked it as failing *)

(* and we include one more example, where x2 is not at the head *)

Lemma bar'' h1 x1 x2 h2 x3 e (q : cont B) : 
  verify (x1 :-> 1 :+ (x2 :-> 4 :+ h1 :+ (h2 :+ x3 :-> 3))) (e tt) q -> 
  verify (x1 :-> 1 :+ ((x2 :-> 4 :+ h1) :+ (h2 :+ x3 :-> 3))) (bind_s (write_s x2 4) e) q.
Proof.
move=>H; by apply: bnd_writeR.
Qed.




